/*
 *      _ L I S T _ E m b e d O u t e r
 *
 *  This is a support function.   It is used to find the outermost
 *  list given the list handle of any of the members of an
 *  embededed list.
 *
 *
 * (c) Copyright 1996-1999 David J. Walker
 *     Email:  dave.walker@icl.com
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  10 July 96  DJW   - First version (used to be part of embed.c)
 */

#include <liblist.h>
#include "liblistx.h"


_embedh_t	_LIST_EmbedOuter (list_t list)
{
	register _embedh_t	embedlist = (_embedh_t)list ; 

	LIBASSERT (LIST_Embedded(list))

	while (embedlist->outer != NULL) 
	{
		embedlist = embedlist->outer;
	}
	return embedlist;
}

