/*
 *      L I S T _ I n d e x
 *
 *  This function is called when it is required
 *  to find out the position of a node in the list.
 *
 *
 * (c) Copyright 1996-1999 David J. Walker
 *     Email:  dave.walker@icl.com
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  18 May 96   DJW   - First version
 */

#include <liblist.h>
#include "liblistx.h"


size_t   LIST_Index (list_t list, node_t node)
{
    long    count;
    node_t  listnode;
    _listmaster_t listmaster;

    LIBDEBUG ("LIST_Index", \
           "'list' parameter is not a valid list instance", \
           _LIST_ListCheck(list))
    LIBDEBUG ("LIST_Index", \
           "'node' is not a valid member of this list type", \
           _LIST_NodeCheck(list,node))

	listmaster = list->listclass->master;

    for (count = 1, listnode = listmaster->first(list) ; listnode != NULL; 
         count++, listnode = listmaster->next(list,_LIST_REALNODE(list,listnode)))
    {
        /*
         *  If the addresses are the same,
         *  then the nodes must be!
         */
        if (listnode == node)
        {
            return (size_t)count;
        }
    }
    /*
     *  If this point reached, then node not found
     */
    return (0);
}

