/*
 *		_ L I S T _ D e b u g
 *
 *	This function is an internal support routine that
 *	is used in the debug version of the library.
 *	It is called whenever the specified test fails.
 *	In many ways it is equivalent to the system assert()
 *	function.
 *
 *	Ideally it should call in the minimum of extra code,
 *	so on systems where we know how to do this we 
 *
 *
 * (c) Copyright 1996-2000 David J. Walker
 *	   Email:  dave.walker@icl.com
 *
 *	   Permission to copy and/or distribute granted under the
 *	   following conditions:
 *
 *	   1). This notice must remain intact.
 *	   2). The author is not responsible for the consequences of use
 *		   this software, no matter how awful, even if they
 *		   arise from defects in it.
 *	   3). Altered version must not be represented as being the
 *		   original software.
 *
 *
 *	AMENDMENT HISTORY
 *	~~~~~~~~~~~~~~~~~
 *	07 Jul 96	DJW   - First version
 */


#include <liblist.h>
#include "liblistx.h"

#include <stdlib.h>

#ifdef LISTDEBUG

#include <stdio.h>
#include <string.h>

#define MSG1 "LIBLIST: Consistency check failed\n"
#define MSG2 "\nPress ENTER to continue\n"
#endif /* LISTDEBUG */

extern
void   _LIST_Debug	 (char * msg)
{
#ifdef LISTDEBUG
	char  buffer[2];

	(void)write (STDERR, MSG1, strlen(MSG1));
	(void)write (STDERR, msg, strlen(msg));
	(void)write (STDERR, MSG2, strlen(MSG2));
	(void)read(STDERR,buffer,1);
#endif /* LISTDEBUG */
	(void) msg;
	exit(-1);
}
