/*
 *      L I S T _ P o p
 *
 *  This function is called when it is required
 *  to remove a node from the start of a list
 *  that is being used as a stack.
 *
 *
 * (c) Copyright 1996-1999 David J. Walker
 *     Email:  dave.walker@icl.com
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  22 May 96   DJW   - First version
 */


#include <liblist.h>
#include "liblistx.h"


node_t  LIST_Pop (list_t list)
{
    node_t  node;

    LIBDEBUG ("LIST_Pop", \
           "'list' parameter is not a valid list instance", \
           _LIST_ListCheck(list))


    if ((node = LIST_First(list)) == NULL)
    {
        return (NULL);
    }
#ifdef LIBTEST
    LIBASSERT(list->listclass->master->remove (list, _LIST_REALNODE(list,node)) == LIST_ERROR_NONE)
#else
    (void) list->listclass->master->remove (list, _LIST_REALNODE(list,node));
#endif /* LIBTEST */
    return (node);

}

